GankListVersion = "1.6mod";

UIPanelWindows["GankListFrame"] = { area = "left", pushable = 0, whileDead = 1 };

StaticPopupDialogs["GANKLIST_ADD"] = {
	text = "Enter name of player to add:",
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	maxLetters = 12,
	OnAccept = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox");
		GankList_Add(editBox:GetText(), 0);
	end,
	OnShow = function()
		getglobal(this:GetName().."EditBox"):SetFocus();
	end,
	OnHide = function()
		if ( ChatFrameEditBox:IsVisible() ) then
			ChatFrameEditBox:SetFocus();
		end
		getglobal(this:GetName().."EditBox"):SetText("");
	end,
	EditBoxOnEnterPressed = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox");
		GankList_Add(editBox:GetText(), 0);
		this:GetParent():Hide();
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide();
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1,
	hideOnEscape = 1
};

StaticPopupDialogs["GANKLIST_KILLED"] = {
  text = "Add %s to your GankList?",
  button1 = "Yes",
  button2 = "No",
  -- sound = "igPlayerInvite",
  OnShow = function()
	GankListTmp.KILLER = GankListTmp.LASTHIT;
  end,
  OnAccept = function()
    GankList_Add(GankListTmp.KILLER, 0);
  end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};

GankListOptions = {
	AskOnKill = true;
	Debug = false;
}

GankListTmp = {
	LASTHIT = nil;
}

GankListBattlegrounds = {
	["Alterac Valley"] = true;
	["Arathi Basin"] = true;
	["Warsong Gulch"] = true;
	["Eye of the Storm"] = true;
	["The Ring of Trials"] = true;
	["The Circle of Blood"] = true;
	["Nagrand Arena"] = true;
	["Blade's Edge Arena"] = true;
}

function GankList_Print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cFF9E9EFF[GankList]|r " .. msg);
end
function GankList_Debug(msg)
	if (GankListOptions.Debug == true) then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFE900E9[GankList]|r " .. msg);
	end
end

function GankList_OnLoad()
	SLASH_GANKLIST1 = "/ganklist";
	SlashCmdList["GANKLIST"] = GankList_ShowFrame;

	this:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH");
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS");
	this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE");
	this:RegisterEvent("MINIMAP_ZONE_CHANGED");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	this:RegisterEvent("CHAT_MSG_ADDON");
end

function GankList_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		if (GankList_DB == nil) then
			GankList_Print("Preparing for first use...");
			GankList_DB = {}
			GankList_Print("You Gank List has been initialised");
		else
			GankList_Print("Addon Loaded");
		end
	end
			
	if (event == "MINIMAP_ZONE_CHANGED" or event == "ZONE_CHANGED_NEW_AREA") then
		local askonkill = GankListOptions.AskOnKill;
		local zone = GetRealZoneText();
		GankList_Debug("Zone changed, checking to see if player entered BG?");
		if (GankListBattlegrounds[zone]) then
			GankList_Debug(zone .. " = BG Zone");
			GankListOptions.AskOnKill = false;
		else
			GankList_Debug(zone .. " fs!= BG Zone");
			GankListOptions.AskOnKill = true;
		end
		if (askonkill ~= GankListOptions.AskOnKill) then
			if (GankListOptions.AskOnKill == true) then
				GankList_Print("Normal Mode");
			else
				GankList_Print("Battlegrounds Mode");
			end
		end
	end
	if (event == "UPDATE_MOUSEOVER_UNIT") then
		--GameTooltip:SetBackdropColor(bdR, bdG, bdB);
		--if (UnitIsPlayer("mouseover")) then
		--	local guild = GetGuildInfo("mouseover");
		--	if (guild) then
		--		local text = GameTooltipTextLeft1:GetText();
		--		GameTooltipTextLeft1:SetText(text .. " <" .. guild .. ">");
		--		GameTooltip:Show();
		--	end
		--end
		if ((UnitIsPlayer("mouseover")) and (UnitIsEnemy("mouseover", "player"))) then
			onList = "no";
			local player = UnitName("mouseover");
			if (GankList_DB[player]) then
				if (GankList_DB[player]["OnList"] == 1) then
					GameTooltipTextLeft1:SetTextColor(1, 0.5, 0.5);
					GameTooltip:SetBackdropColor(1, 0, 0);
					GameTooltip:Show()
				else 
					if (GankList_DB[player]["OnList"] >= 2) then
						GameTooltipTextLeft1:SetTextColor(1, 0.5, 0.5);
						GameTooltip:SetBackdropColor(1, 0.5, 0);
						GameTooltip:Show()
					end
				end
			end
		end
	end
	if (event == "CHAT_MSG_COMBAT_FRIENDLY_DEATH") then
		if (arg1 == "You die.") then
			GankList_Debug(UnitName("player") .. " died");
			if (GankListTmp.LASTHIT) then
				--TargetByName(GankListTmp.LASTHIT);
				--if (UnitIsPlayer("target")) then
					local name = (GankListTmp.LASTHIT);
					--local name = UnitName("target");
					--GankList_Print("|cFFE90000You were slain by " .. name);
					if (GankListOptions.AskOnKill == true) then
						if (not GankList_DB[name]) then
							StaticPopup_Show("GANKLIST_KILLED", GankListTmp.LASTHIT);
						else
							if (GankList_DB[name]["OnList"] >= 2) then
								StaticPopup_Show("GANKLIST_KILLED", GankListTmp.LASTHIT);
							end
						end
					end
				--end
			end
		end
	end
	if (event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE") then
		tmpstart, tmpend, name, spell, attacktype, dmg = string.find(arg1, "(.+)'s (.+) (.+) you for (.+).");
		if (dmg) then GankListTmp.LASTHIT = name; end
	end
	if (event == "CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS") then
		tmpstart, tmpend, name, attacktype, dmg = string.find(arg1, "(.+) (.+) you for (.+)%.");
		if (dmg) then GankListTmp.LASTHIT = name; end
	end
	if (event == "CHAT_MSG_ADDON") then
		local playerName = UnitName("player");
		if (arg1 == "GankListGuild" and not(arg4 == playerName)) then
			GankList_Add(arg2, 1);
			GankList_Print(arg2 .. "Added to GankList, Received from:" .. arg4);
		end
	end
end

function GankList_ShowFrame()
    if (GankListFrame:IsVisible()) then
		HideUIPanel(GankListFrame);
	else
		ShowUIPanel(GankListFrame);
	end
end

function GankList_Add(msg, guild)
	local numChar = string.len(msg);
	if(string.find(msg, "'s", numChar-2)) then
		msg = string.sub(msg, 1 , numChar-2);
	end
	if(GankList_DB[msg] and GankList_DB[msg]["OnList"] >= 2) then
		if(guild == 0) then
			GankList_DB[msg]["OnList"] = 1;
			SendAddonMessage( "GankListGuild", msg, "GUILD" );
		else
			GankList_DB[msg]["OnList"] = GankList_DB[msg]["OnList"] + 1;
		end
	else
		if((not GankList_DB[msg])) then
			local a,b,c=strfind(msg, "(%S+)"); --contiguous string of non-space characters
			local basename = string.sub(c, a, b);
			local name = string.upper(string.sub(basename, 0, 1))
			name = name .. string.lower(string.sub(basename, 2))
			if (GankList_DB[name] == nil) then GankList_DB[name] = {} end
			
			if(guild == 0) then
				GankList_DB[name]["OnList"] = 1;
				SendAddonMessage( "GankListGuild", name, "GUILD" );
			else
				GankList_DB[name]["OnList"] = 2;
			end
			
			GankList_Print(name .. " added to your Gank List");
		end
	end
	
	if (GankListFrame:IsVisible()) then
		GankList_Update();
	end
	
end

function GankList_Remove()
	local nameOffset = FauxScrollFrame_GetOffset(GankListNameScrollFrame);
	local nameIndex = GankListFrame.selectedName - nameOffset;
	local nameButton = getglobal("GankListNameButton".. nameIndex .."ButtonTextName");
	local name = nameButton:GetText();
	GankList_DB[name] = nil;
	
	GankList_Print(name .. " removed from your Gank List");

	if (GankListFrame:IsVisible()) then
		GankList_Update();
	end
end

function GankList_Update()
	local names = {}
      local i = 0;
	for index, value in pairs (GankList_DB) do
		if (GankList_DB[index]["OnList"] == 1) then
			table.insert(names, index)
			i = i + 1;
		else 
			if (GankList_DB[index]["OnList"] >= 2) then	
				table.insert(names, "|cff888888" .. "[" .. GankList_DB[index]["OnList"] - 1 .. "] " .. index)
				i = i + 1;
			end
		end
	end

	table.sort(names);

	local numNames = i;
	local nameText;
	local name;
	local nameButton;
	if ( numNames > 0 ) then
		if (GankListFrame.selectedName == 0) then
			GankListFrame.selectedName = 1;
		end
		GankListRemovePlayerButton:Enable();
	else
		GankListRemovePlayerButton:Disable();
	end
	
	local currentMode = nil;
	if (GankListOptions.AskOnKill == true) then
		currentMode = "Normal";
	else
		currentMode = "Battlegrounds";
	end
	GankListTopText1:SetText(GetRealmName());
	GankListTopText2:SetText("There are " .. numNames .. " names on your Gank List");
	GankListTopText3:SetText("[" .. currentMode .. " Mode]");

	local nameOffset = FauxScrollFrame_GetOffset(GankListNameScrollFrame);
	local nameIndex;
	for i=1, 20, 1 do
		nameIndex = i + nameOffset;
		nameText = getglobal("GankListNameButton"..i.."ButtonTextName");
		nameText:SetText(names[nameIndex]);
		nameButton = getglobal("GankListNameButton"..i);
		nameButton:SetID(nameIndex);
		-- Update the highlight
		if ( nameIndex == GankListFrame.selectedName ) then
			nameButton:LockHighlight();
		else
			nameButton:UnlockHighlight();
		end
		
		if ( nameIndex > numNames ) then
			nameButton:Hide();
		else
			nameButton:Show();
		end
	end
	
	-- ScrollFrame stuff
	FauxScrollFrame_Update(GankListNameScrollFrame, numNames, 20, 16 );
end

function GankListNameButton_OnClick(button)
	if( IsShiftKeyDown() and ChatFrameEditBox:IsVisible() ) then
		local ButtonTextName = getglobal(this:GetName() .. "ButtonTextName");
		local name = ButtonTextName:GetText();
		local text = ChatFrameEditBox:GetText();
		ChatFrameEditBox:SetText(text .. name);
	end
	GankListFrame.selectedName = this:GetID();
	GankList_Update();
end